Attribute VB_Name = "CodeUtilities"
'   Commentator (Visual Basic Comment Manager) v1.0.0
'   Copyright (C) 2001 Justin Wesley jwesley@cryptofreak.org
'
'   This program is free software; you can redistribute it and/or
'   modify it under the terms of the GNU General Public License
'   as published by the Free Software Foundation; either version 2
'   of the License, or (at your option) any later version.
'
'   This program is distributed in the hope that it will be useful,
'   but WITHOUT ANY WARRANTY; without even the implied warranty of
'   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'   GNU General Public License for more details.
'
'   You should have received a copy of the GNU General Public License
'   along with this program; if not, write to the Free Software
'   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
Option Explicit

Public Enum genmShowComponentType
   sctShowNone = 0
   sctShowProperties = 1
   sctShowSubs = 2
   sctShowFunctions = 4
   sctShowEvents = 8
   sctShowPrivate = 16
   sctShowPublic = 32
   sctShowFriend = 64
   sctShowUncommentedOnly = 128
End Enum

Public Const gstrICOMMENTCLASS As String = "JWDev.VBComment"
Public Const gintSAVEFILES As Integer = vbChecked
Public Const gstrPROJECTFONT As String = "MS Sans Serif"

Public Sub CommentMethod(VBInstance As VBIDE.VBE, Path As String)
   Dim vbProject As vbProject
   Dim vbComponent As vbComponent
   Dim vbMember As Member
   Dim aryTmp As Variant
   Dim lstrRoot As String
   Dim lstrProject As String
   Dim lstrComponent As String
   Dim lstrMethod As String
   Dim lstrLine As String
   Dim llngTmp As Long
   Dim lblnTmp As Boolean
   Dim lintMemberType As Integer
   Dim lstrHeader As String
   Dim lstrBuffer As String
   Dim lobjCommenter As JWCmnt.IComment1
   
   Set lobjCommenter = CreateObject(GetSetting(App.Title, "Implementations", "IComment1", gstrICOMMENTCLASS))
   
   aryTmp = Split(Path, "\")

   'first is root
   lstrRoot = aryTmp(0)

   'Then Project
   lstrProject = aryTmp(1)

   ' Then Component
   lstrComponent = aryTmp(2)

   ' Then method
   lstrMethod = aryTmp(3)

   If InStr(1, lstrMethod, " (Get)") <> 0 Then
      ' We have a get property
      lintMemberType = vbext_pk_Get
      lstrMethod = Replace(lstrMethod, " (Get)", "")
   ElseIf InStr(1, lstrMethod, " (Let)") <> 0 Then
      ' We have a let property
      lintMemberType = vbext_pk_Let
      lstrMethod = Replace(lstrMethod, " (Let)", "")
   ElseIf InStr(1, lstrMethod, " (Set)") <> 0 Then
      ' We have a set property
      lintMemberType = vbext_pk_Set
      lstrMethod = Replace(lstrMethod, " (Set)", "")
   Else
      ' We have a method
      lintMemberType = vbext_pk_Proc
   End If
   
   lblnTmp = True

   For Each vbProject In VBInstance.VBProjects
      If vbProject.Name = lstrProject Then
         For Each vbComponent In vbProject.VBComponents
            If vbComponent.Name = lstrComponent Then
               For Each vbMember In vbComponent.CodeModule.Members
                  If vbMember.Name = lstrMethod Then
                     ' Mark it as dirty
                     vbComponent.IsDirty = True
                     lstrBuffer = vbComponent.CodeModule.Lines(vbComponent.CodeModule.ProcBodyLine(vbMember.Name, lintMemberType), (vbComponent.CodeModule.ProcCountLines(vbMember.Name, lintMemberType)) - (vbComponent.CodeModule.ProcBodyLine(vbMember.Name, lintMemberType) - vbComponent.CodeModule.ProcStartLine(vbMember.Name, lintMemberType)))
                     llngTmp = vbComponent.CodeModule.ProcBodyLine(vbMember.Name, lintMemberType)
                     Select Case lintMemberType
                        Case vbext_pk_Get, vbext_pk_Let, vbext_pk_Set
                           lstrBuffer = lobjCommenter.CommentProperty(lstrBuffer)
                        Case vbext_pk_Proc
                           lstrHeader = vbComponent.CodeModule.Lines(vbComponent.CodeModule.ProcBodyLine(vbMember.Name, vbext_pk_Proc), 1)
                           If InStr(1, lstrHeader, "Function", vbTextCompare) <> 0 Then
                              lstrBuffer = lobjCommenter.CommentFunction(lstrBuffer)
                           Else
                              lstrBuffer = lobjCommenter.CommentSub(lstrBuffer)
                           End If
                        Case Else
                           ' Error
                     End Select
                     vbComponent.CodeModule.DeleteLines llngTmp, (vbComponent.CodeModule.ProcCountLines(vbMember.Name, lintMemberType)) - (vbComponent.CodeModule.ProcBodyLine(vbMember.Name, lintMemberType) - vbComponent.CodeModule.ProcStartLine(vbMember.Name, lintMemberType))
                     vbComponent.CodeModule.InsertLines llngTmp, lstrBuffer
                  End If
               Next vbMember
            End If
         Next vbComponent
      End If
   Next vbProject

   Set vbProject = Nothing
   Set vbComponent = Nothing
   Set vbMember = Nothing
   Set lobjCommenter = Nothing
End Sub

Public Sub CommentModule(VBInstance As VBIDE.VBE, Path As String)
   Dim vbProject As vbProject
   Dim vbComponent As vbComponent
   Dim aryTmp As Variant
   Dim lstrRoot As String
   Dim lstrProject As String
   Dim lstrComponent As String
   Dim lstrLine As String
   Dim llngTmp As Long
   Dim lblnTmp As Boolean
   Dim lstrHeader As String
   Dim lstrBuffer As String
   Dim lobjCommenter As JWCmnt.IComment1
   
   Set lobjCommenter = CreateObject(GetSetting(App.Title, "Implementations", "IComment1", gstrICOMMENTCLASS))
   
   aryTmp = Split(Path, "\")

   'first is root
   lstrRoot = aryTmp(0)

   'Then Project
   lstrProject = aryTmp(1)

   ' Then Component
   lstrComponent = aryTmp(2)
   
   lblnTmp = True

   For Each vbProject In VBInstance.VBProjects
      If vbProject.Name = lstrProject Then
         For Each vbComponent In vbProject.VBComponents
            If vbComponent.Name = lstrComponent Then
               ' Mark it as dirty
               vbComponent.IsDirty = True
               lstrBuffer = vbComponent.CodeModule.Lines(1, vbComponent.CodeModule.CountOfLines)
               lstrBuffer = lobjCommenter.CommentModule(lstrBuffer)
               vbComponent.CodeModule.DeleteLines 1, vbComponent.CodeModule.CountOfLines
               vbComponent.CodeModule.InsertLines 1, lstrBuffer
            End If
         Next vbComponent
      End If
   Next vbProject

   Set vbProject = Nothing
   Set vbComponent = Nothing
   Set lobjCommenter = Nothing
End Sub

Public Function MethodHasComments(VBInstance As VBIDE.VBE, Path As String) As Boolean
   Dim vbProject As vbProject
   Dim vbComponent As vbComponent
   Dim vbMember As Member
   Dim aryTmp As Variant
   Dim lstrRoot As String
   Dim lstrProject As String
   Dim lstrComponent As String
   Dim lstrMethod As String
   Dim lstrLine As String
   Dim lblnTmp As Boolean
   Dim lintMemberType As Integer
   
   On Error GoTo errTemp
   
   aryTmp = Split(Path, "\")
   
   'first is root
   lstrRoot = aryTmp(0)
   
   'Then Project
   lstrProject = aryTmp(1)
   
   ' Then Component
   lstrComponent = aryTmp(2)
   
   ' Then method
   lstrMethod = aryTmp(3)
   
   lblnTmp = True
   
   If InStr(1, lstrMethod, " (Get)") <> 0 Then
      ' We have a get property
      lintMemberType = vbext_pk_Get
      lstrMethod = Replace(lstrMethod, " (Get)", "")
   ElseIf InStr(1, lstrMethod, " (Let)") <> 0 Then
      ' We have a let property
      lintMemberType = vbext_pk_Let
      lstrMethod = Replace(lstrMethod, " (Let)", "")
   ElseIf InStr(1, lstrMethod, " (Set)") <> 0 Then
      ' We have a set property
      lintMemberType = vbext_pk_Set
      lstrMethod = Replace(lstrMethod, " (Set)", "")
   Else
      ' We have a method
      lintMemberType = vbext_pk_Proc
   End If

   lstrLine = VBInstance.VBProjects(lstrProject).VBComponents(lstrComponent).CodeModule.Lines(VBInstance.VBProjects(lstrProject).VBComponents(lstrComponent).CodeModule.ProcBodyLine(lstrMethod, lintMemberType) - 1, 1)
'   For Each vbProject In VBInstance.VBProjects
'      If vbProject.Name = lstrProject Then
'         For Each vbComponent In vbProject.VBComponents
'            If vbComponent.Name = lstrComponent Then
'               For Each vbMember In vbComponent.CodeModule.Members
'                  If vbMember.Name = lstrMethod Then
'                     lstrLine = vbComponent.CodeModule.Lines(vbComponent.CodeModule.ProcBodyLine(vbMember.Name, lintMemberType) - 1, 1)
                     If Left(Trim(lstrLine), 1) = "'" Then
                        lblnTmp = True
                     Else
                        lblnTmp = False
                     End If
'                  End If
'               Next vbMember
'            End If
'         Next vbComponent
'      End If
'   Next vbProject
   
   MethodHasComments = lblnTmp
   
   Set vbProject = Nothing
   Set vbComponent = Nothing
   Set vbMember = Nothing
   
   Exit Function
errTemp:
   MethodHasComments = True
End Function

Public Function ModuleHasComments(VBInstance As VBIDE.VBE, Path As String) As Boolean
   Dim vbProject As vbProject
   Dim vbComponent As vbComponent
   Dim aryTmp As Variant
   Dim lstrRoot As String
   Dim lstrProject As String
   Dim lstrComponent As String
   Dim lstrLine As String
   Dim lblnTmp As Boolean
   
   On Error GoTo errTemp
   
   aryTmp = Split(Path, "\")
   
   'first is root
   lstrRoot = aryTmp(0)
   
   'Then Project
   lstrProject = aryTmp(1)
   
   ' Then Component
   lstrComponent = aryTmp(2)
   
   lblnTmp = True

   lstrLine = VBInstance.VBProjects(lstrProject).VBComponents(lstrComponent).CodeModule.Lines(1, 1)
   If Left(Trim(lstrLine), 1) = "'" Then
      lblnTmp = True
   Else
      lblnTmp = False
   End If
   
   ModuleHasComments = lblnTmp
   
   Set vbProject = Nothing
   Set vbComponent = Nothing
   
   Exit Function
errTemp:
   ModuleHasComments = True
End Function

Public Function GetProjects(VBInstance As VBIDE.VBE) As Collection
   Dim lcolTmp As Collection
   Dim vbProject As vbProject

   Set lcolTmp = New Collection
   For Each vbProject In VBInstance.VBProjects
      lcolTmp.Add vbProject.Name
   Next vbProject

   Set GetProjects = lcolTmp
   Set lcolTmp = Nothing
   Set vbProject = Nothing
   
End Function

Public Function GetComponents(VBInstance As VBIDE.VBE, ProjectName As String) As Collection
   Dim lcolTmp As Collection
   Dim vbProject As vbProject
   Dim lintIndex As Integer

   On Error GoTo errGetComponents
   
   Set lcolTmp = New Collection
   Set vbProject = VBInstance.VBProjects(ProjectName)
   'For Each vbProject In VBInstance.VBProjects
      'If vbProject.Name = ProjectName Then
         For lintIndex = 1 To vbProject.VBComponents.Count
            If vbProject.VBComponents(lintIndex).Type = vbext_ct_ClassModule _
                  Or vbProject.VBComponents(lintIndex).Type = vbext_ct_StdModule _
                  Or vbProject.VBComponents(lintIndex).Type = vbext_ct_UserControl _
                  Or vbProject.VBComponents(lintIndex).Type = vbext_ct_VBForm _
                  Or vbProject.VBComponents(lintIndex).Type = vbext_ct_VBMDIForm Then
               lcolTmp.Add vbProject.VBComponents(lintIndex).Name
            End If
         Next lintIndex
      'End If
   'Next vbProject
   Set GetComponents = lcolTmp

   Set lcolTmp = Nothing
   Set vbProject = Nothing
   
   Exit Function
   
errGetComponents:
   MsgBox "An error  occurred while retrieving component names." & vbCrLf & vbCrLf & Err.Number & ": " & Err.Description
End Function

Public Function GetAllMembers(VBInstance As VBIDE.VBE, ComponentName As String, CType As genmShowComponentType) As Collection
   Dim lcolTmp As Collection
   Dim vbProject As vbProject
   Dim vbComponent As vbComponent
   Dim Member As Member
   Dim llngTmp As Long
   Dim lblnTmp As Boolean
   Dim lstrTmp As String
   
   On Error GoTo errGetAllMembers
   
   Set lcolTmp = New Collection
   For Each vbProject In VBInstance.VBProjects
      Set vbComponent = vbProject.VBComponents(ComponentName)
      'For Each vbComponent In vbProject.VBComponents
         'If vbComponent.Name = ComponentName Then
            For Each Member In vbComponent.CodeModule.Members
               lblnTmp = False
               
'               ' Check has comments flag
'               If CType And sctShowUncommentedOnly Then
'                  If Not MethodHasComments(VBInstance, "Root" & "\" & vbProject.Name & "\" & vbComponent.Name & "\" & Member.Name) Then
'                     lblnTmp = True
'                  End If
'               Else
'                  lblnTmp = True
'               End If
               
'               If lblnTmp = True Then
               lblnTmp = False
               If Member.Scope = vbext_Public Then
                  If (CType And sctShowPublic) = sctShowPublic Then
                     lblnTmp = True
                  End If
               ElseIf Member.Scope = vbext_Private Then
                  If (CType And sctShowPrivate) = sctShowPrivate Then
                     lblnTmp = True
                  End If
               ElseIf Member.Scope = vbext_Friend Then
                  If (CType And sctShowFriend) = sctShowFriend Then
                     lblnTmp = True
                  End If
               End If
'               End If
               
               If lblnTmp Then
                  If Member.Type = vbext_mt_Method Then
                     llngTmp = vbComponent.CodeModule.ProcBodyLine(Member.Name, vbext_pk_Proc)
                     lstrTmp = vbComponent.CodeModule.Lines(llngTmp, 1)
                     If InStr(1, lstrTmp, "Function") <> 0 Then
                        ' it is a function
                           If (CType And sctShowFunctions) = sctShowFunctions Then
                              If CType And sctShowUncommentedOnly Then
                                 If Not MethodHasComments(VBInstance, "Root" & "\" & vbProject.Name & "\" & vbComponent.Name & "\" & Member.Name) Then
                                    lcolTmp.Add Member.Name
                                 End If
                              Else
                                 lcolTmp.Add Member.Name
                              End If
                           End If
                     Else
                        ' it is a sub
                        If (CType And sctShowSubs) = sctShowSubs Then
                           If CType And sctShowUncommentedOnly Then
                              If Not MethodHasComments(VBInstance, "Root" & "\" & vbProject.Name & "\" & vbComponent.Name & "\" & Member.Name) Then
                                 lcolTmp.Add Member.Name
                              End If
                           Else
                              lcolTmp.Add Member.Name
                           End If
                        End If
                     End If
                  ElseIf Member.Type = vbext_mt_Event Then
                     If (CType And sctShowEvents) = sctShowEvents Then
                        If CType And sctShowUncommentedOnly Then
                           If Not MethodHasComments(VBInstance, "Root" & "\" & vbProject.Name & "\" & vbComponent.Name & "\" & Member.Name) Then
                              lcolTmp.Add Member.Name
                           End If
                        Else
                           lcolTmp.Add Member.Name
                        End If
                     End If
                  ElseIf Member.Type = vbext_mt_Property Then
                     If (CType And sctShowProperties) = sctShowProperties Then
                        On Error Resume Next
                        ' See if there is a get property
                        llngTmp = vbComponent.CodeModule.ProcBodyLine(Member.Name, vbext_pk_Get)
                        If Err.Number = 0 Then
                           If CType And sctShowUncommentedOnly Then
                              If Not MethodHasComments(VBInstance, "Root" & "\" & vbProject.Name & "\" & vbComponent.Name & "\" & Member.Name & " (Get)") Then
                                 lcolTmp.Add Member.Name & " (Get)"
                              End If
                           Else
                              lcolTmp.Add Member.Name & " (Get)"
                           End If
                        End If
                        Err.Clear
                        
                        ' See if there is a let property
                        llngTmp = vbComponent.CodeModule.ProcBodyLine(Member.Name, vbext_pk_Let)
                        If Err.Number = 0 Then
                           If CType And sctShowUncommentedOnly Then
                              If Not MethodHasComments(VBInstance, "Root" & "\" & vbProject.Name & "\" & vbComponent.Name & "\" & Member.Name & " (Let)") Then
                                 lcolTmp.Add Member.Name & " (Let)"
                              End If
                           Else
                              lcolTmp.Add Member.Name & " (Let)"
                           End If
                        End If
                        Err.Clear
                        
                        ' See if there is a set property
                        llngTmp = vbComponent.CodeModule.ProcBodyLine(Member.Name, vbext_pk_Set)
                        If Err.Number = 0 Then
                           If CType And sctShowUncommentedOnly Then
                              If Not MethodHasComments(VBInstance, "Root" & "\" & vbProject.Name & "\" & vbComponent.Name & "\" & Member.Name & " (Set)") Then
                                 lcolTmp.Add Member.Name & " (Set)"
                              End If
                           Else
                              lcolTmp.Add Member.Name & " (Set)"
                           End If
                        End If
                        Err.Clear
                        
                     End If
                  End If
               End If
               
            Next Member
         'End If
      'Next vbComponent
   Next vbProject

   Set GetAllMembers = lcolTmp
   
   Set lcolTmp = Nothing
   Set vbProject = Nothing
   Set vbComponent = Nothing
   Set Member = Nothing

   Exit Function
   
errGetAllMembers:
   MsgBox "An error  occurred while retrieving member names." & vbCrLf & vbCrLf & Err.Number & ": " & Err.Description
End Function
