VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SubWrapper"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'   Commentator (Visual Basic Comment Manager) v1.0.0
'   Copyright (C) 2001 Justin Wesley jwesley@cryptofreak.org
'
'   This program is free software; you can redistribute it and/or
'   modify it under the terms of the GNU General Public License
'   as published by the Free Software Foundation; either version 2
'   of the License, or (at your option) any later version.
'
'   This program is distributed in the hope that it will be useful,
'   but WITHOUT ANY WARRANTY; without even the implied warranty of
'   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'   GNU General Public License for more details.
'
'   You should have received a copy of the GNU General Public License
'   along with this program; if not, write to the Free Software
'   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
Option Explicit
Option Compare Text

Private Const mstrDEFAULTSCOPE As String = "Public"

Private mstrSubText As String
Private mstrScope As String
Private mstrName As String
Private mstrHeader As String
Private mstrArgumentLine As String
Private mobjArgList As ArgumentList

Public Function BuildComments() As String
   Dim lstrBuffer As String
   Dim lstrTmp As String
   Dim lstrInitial As String
   Dim lstrMid As String
   Dim lstrLast As String
   Dim lstrSingle As String
   Dim lstrArguments As String
   Dim lintTmp As Integer
   Dim lintIndex As Integer
   Dim lintLastPos As Integer
   Dim lblnFoundDash As Boolean
   Dim lblnInInitial As Boolean
   Dim lblnInSingle As Boolean
   Dim lblnDone As Boolean
   Dim lblnInMid As Boolean
   Dim lblnInLast As Boolean
   Dim lobjFSO As FileSystemObject
   Dim lstrHeader As String
   Dim lstrFooter As String
   Dim lstrLine As String
   Dim lstrTabWidth As String
   Dim lstrBlock As String
   Dim lobjStream As TextStream
   
   Set lobjFSO = New FileSystemObject
   
   If lobjFSO.FileExists(App.Path & "\JWDevSub.txt") Then
      Set lobjStream = lobjFSO.OpenTextFile(App.Path & "\JWDevSub.txt", ForReading, False)
      lstrHeader = lobjStream.ReadLine
      lstrFooter = lobjStream.ReadLine
      lstrLine = lobjStream.ReadLine
      lstrTabWidth = lobjStream.ReadLine
      Do While Not lobjStream.AtEndOfStream
         lstrBlock = lstrBlock & lobjStream.Read(1)
      Loop
      lobjStream.Close
   Else
      lstrHeader = "'******"
      lstrFooter = "'******"
      lstrLine = "'*"
      lstrTabWidth = "3"
      lstrBlock = "Sub Comment"
   End If
      
   lstrTmp = lstrBlock
   
   ' Remove all trailing vbcrlf's
   Do While (Len(lstrTmp) > 1) And (Not lblnDone)
      If Right(lstrTmp, 2) = vbCrLf Then
         lstrTmp = Left(lstrTmp, Len(lstrTmp) - 2)
      Else
         lblnDone = True
      End If
   Loop
   
   If Len(lstrTmp) > 0 Then
      lstrTmp = lstrLine & Space(CInt(lstrTabWidth)) & _
            Replace(lstrTmp, vbCrLf, vbCrLf & lstrLine & Space(CInt(lstrTabWidth)))
   End If
   
   ' Replace Special Characters
   
   lstrTmp = Replace(lstrTmp, "[%n]", mstrName)
   lstrTmp = Replace(lstrTmp, "[%h]", mstrHeader)
   lstrTmp = Replace(lstrTmp, "[%DATE]", Date)
   lstrTmp = Replace(lstrTmp, "[%TIME]", Time)
   lstrTmp = Replace(lstrTmp, "[%al]", mstrArgumentLine)
   lintTmp = InStr(1, lstrTmp, "[%av")
   If lintTmp <> 0 Then
      ' Find the next ] char
      lintIndex = lintTmp + 4
      Do While lintIndex <= Len(lstrTmp) And Mid(lstrTmp, lintIndex, 1) <> "]"
         lstrBuffer = lstrBuffer & Mid(lstrTmp, lintIndex, 1)
         lintIndex = lintIndex + 1
      Loop
      If lintIndex <= Len(lstrTmp) Then
         lintLastPos = lintIndex
      End If
      If lintLastPos <> 0 Then
         For lintIndex = 1 To Len(lstrBuffer)
            lblnInSingle = (lblnFoundDash And (Mid(lstrBuffer, lintIndex, 1) = "s")) _
               Or (lblnInSingle)
            lblnInInitial = (lblnFoundDash And (Mid(lstrBuffer, lintIndex, 1) = "i")) _
                  Or (lblnInInitial)
            lblnInMid = (lblnFoundDash And (Mid(lstrBuffer, lintIndex, 1) = "m")) _
                  Or (lblnInMid)
            lblnInLast = (lblnFoundDash And (Mid(lstrBuffer, lintIndex, 1) = "l")) _
                  Or (lblnInLast)
            lblnFoundDash = (Mid(lstrBuffer, lintIndex, 1) = "-") _
                 And ((Mid(lstrBuffer, lintIndex + 1, 1) = "i") Or _
                 (Mid(lstrBuffer, lintIndex + 1, 1) = "m") Or _
                 (Mid(lstrBuffer, lintIndex + 1, 1) = "l") Or _
                 (Mid(lstrBuffer, lintIndex + 1, 1) = "s"))
            If lblnFoundDash Then
               lblnInInitial = False
               lblnInSingle = False
               lblnInMid = False
               lblnInLast = False
            End If
            
            If lblnInInitial Then
               lstrInitial = lstrInitial & Mid(lstrBuffer, lintIndex, 1)
            End If
            If lblnInMid Then
               lstrMid = lstrMid & Mid(lstrBuffer, lintIndex, 1)
            End If
            If lblnInLast Then
               lstrLast = lstrLast & Mid(lstrBuffer, lintIndex, 1)
            End If
            If lblnInSingle Then
               lstrSingle = lstrSingle & Mid(lstrBuffer, lintIndex, 1)
            End If
         Next lintIndex
         
         ' Cut off symbols
         lstrInitial = Mid(lstrInitial, 2)
         lstrMid = Mid(lstrMid, 2)
         lstrLast = Mid(lstrLast, 2)
         lstrSingle = Mid(lstrSingle, 2)
         
         lstrArguments = ""
         For lintIndex = 1 To mobjArgList.Count
            If mobjArgList.Count = 1 Then
               lstrArguments = lstrArguments & lstrSingle
            Else
               If lintIndex = mobjArgList.Count Then
                  lstrArguments = lstrArguments & lstrLast
               ElseIf lintIndex = 1 Then
                  lstrArguments = lstrInitial
               Else
                  lstrArguments = lstrArguments & lstrMid
               End If
            End If
            ' Substitute argument properties in
            lstrArguments = Replace(lstrArguments, "%a.o", mobjArgList(lintIndex).IsOptional)
            lstrArguments = Replace(lstrArguments, "%a.d", mobjArgList(lintIndex).DefaultValue)
            lstrArguments = Replace(lstrArguments, "%a.b", mobjArgList(lintIndex).ByType)
            lstrArguments = Replace(lstrArguments, "%a.t", mobjArgList(lintIndex).ArgType)
            lstrArguments = Replace(lstrArguments, "%a.p", mobjArgList(lintIndex).IsParamArray)
            lstrArguments = Replace(lstrArguments, "%a.n", mobjArgList(lintIndex).ArgName)
            
         Next lintIndex
         
         lstrTmp = Mid(lstrTmp, 1, lintTmp - 1) & lstrArguments & Mid(lstrTmp, lintLastPos + 1)
      End If
      
   End If
   
   lblnDone = False
   ' Remove all trailing vbcrlf's
   Do While (Len(lstrTmp) > 1) And (Not lblnDone)
      If Right(lstrTmp, 2) = vbCrLf Then
         lstrTmp = Left(lstrTmp, Len(lstrTmp) - 2)
      Else
         lblnDone = True
      End If
   Loop
   
   lstrBuffer = lstrHeader & vbCrLf & lstrTmp & IIf(Len(lstrTmp) > 0, vbCrLf, "") & lstrFooter & vbCrLf
   
   lstrBuffer = Replace(lstrBuffer, "\n", vbCrLf & lstrLine & Space(CInt(lstrTabWidth)))
   lstrBuffer = Replace(lstrBuffer, "\t", Space(lstrTabWidth))
   ' Ensure a trailing vbcrlf
   If Len(lstrBuffer) > 1 Then
      If Right(lstrBuffer, 2) <> vbCrLf Then
         lstrBuffer = lstrBuffer & vbCrLf
      End If
   End If
   lstrBuffer = lstrBuffer & mstrSubText
   BuildComments = lstrBuffer
End Function

Public Sub Init(ByVal vstrSubText As String)
   Dim lstrTmp As String
   
   mstrSubText = vstrSubText
   lstrTmp = PrepareVBFunction(mstrSubText)
   mstrScope = GetSubScope(lstrTmp)
   mstrHeader = GetSubHeader(lstrTmp)
   mstrArgumentLine = GetArgLine(lstrTmp)
   Set mobjArgList = GetSubArgList(lstrTmp)
   mstrName = GetSubName(lstrTmp)
   
End Sub

Public Property Get Header() As String
   Header = mstrHeader
End Property

Public Property Get ArgLine() As String
   ArgLine = mstrArgumentLine
End Property

Public Property Get Scope() As String
   Scope = mstrScope
End Property

Public Property Get ArgList() As ArgumentList
   Set ArgList = mobjArgList
End Property

Public Property Get Name() As String
   Name = mstrName
End Property

Private Function GetSubScope(ByVal vstrFCode As String) As String
   Dim lstrTmp As String
   Dim lstrScope As String
   Dim llngPos As Long
   
   lstrTmp = PrepareVBFunction(vstrFCode)
      
   ' The first token should be the scope
   llngPos = InStr(1, lstrTmp, " ")
   If llngPos <> 0 Then
      If Mid(lstrTmp, 1, llngPos - 1) = "Sub" Then
         ' Use default scope
         lstrScope = mstrDEFAULTSCOPE
      Else
         lstrScope = Mid(lstrTmp, 1, llngPos - 1)
         If InStr(llngPos + 1, lstrTmp, " ") <> 0 Then
            ' Check the second token
            If Mid(lstrTmp, llngPos + 1, InStr(llngPos + 1, lstrTmp, " ")) = "STATIC" Then
               lstrScope = lstrScope & " Static"
            End If
         End If
      End If
   Else
      ' We were passed an invalid string
      lstrScope = ""
   End If
   
   GetSubScope = lstrScope
   
End Function

Private Function GetSubArgList(ByVal vstrFCode As String) As ArgumentList
   Dim lstrTmp As String
   Dim lstrArgList As String
   Dim llngPos As Long
   Dim laryArgs As Variant
   Dim lintIndex As Integer
   Dim lobjArg As Argument
   Dim laryTokens As Variant
   Dim lintIndexInner As Integer
   Dim lobjArgList As ArgumentList
   
   Set lobjArgList = New ArgumentList
   
   lstrTmp = PrepareVBFunction(vstrFCode)
   
   ' Find the first "("
   llngPos = InStr(1, lstrTmp, "(")
   If llngPos <> 0 Then
      If InStr(llngPos, lstrTmp, ")") <> 0 Then
         ' Everything in between is the argument list
         lstrArgList = Trim(Mid(lstrTmp, llngPos + 1, InStr(llngPos, lstrTmp, ")") - llngPos - 1))
      Else
         lstrArgList = ""
      End If
   Else
      lstrArgList = ""
   End If
   
   ' Parse Argument List
   laryArgs = Split(lstrArgList, ",")
   
   For lintIndex = LBound(laryArgs) To UBound(laryArgs)
      Set lobjArg = New Argument
      laryTokens = Split(Trim(laryArgs(lintIndex)), " ")
      For lintIndexInner = LBound(laryTokens) To UBound(laryTokens)
         If laryTokens(lintIndexInner) = "Optional" Then
            lobjArg.IsOptional = True
            If laryTokens(lintIndexInner + 1) <> "ByVal" And laryTokens(lintIndexInner + 1) <> "byref" Then
               lobjArg.ArgName = laryTokens(lintIndexInner)
            End If
         End If
         If laryTokens(lintIndexInner) = "ByVal" Then
            lobjArg.ByType = "ByVal"
            lobjArg.ArgName = laryTokens(lintIndexInner + 1)
         End If
         If laryTokens(lintIndexInner) = "ByRef" Then
            lobjArg.ByType = "ByRef"
            lobjArg.ArgName = laryTokens(lintIndexInner + 1)
         End If
         If laryTokens(lintIndexInner) = "ParamArray" Then
            lobjArg.IsParamArray = True
            lobjArg.ArgName = laryTokens(lintIndexInner + 1)
         End If
         If laryTokens(lintIndexInner) = "As" Then
            lobjArg.ArgType = laryTokens(lintIndexInner + 1)
         End If
         If laryTokens(lintIndexInner) = "=" Then
            lobjArg.DefaultValue = laryTokens(lintIndexInner + 1)
         End If
      Next lintIndexInner
      If lobjArg.ArgName = "" Then
         lobjArg.ArgName = laryTokens(LBound(laryTokens))
      End If
      
      lobjArgList.Add lobjArg
   Next lintIndex
   
   Set GetSubArgList = lobjArgList
   
   Set lobjArg = Nothing
   Set lobjArgList = Nothing
   
End Function

Private Function GetSubName(ByVal vstrFCode As String) As String
   Dim lstrTmp As String
   Dim lstrSubName As String
   Dim llngSubPlace As Long
   Dim llngParenPlace As Long
   
   lstrTmp = PrepareVBFunction(vstrFCode)
   
   ' Find first occurrence of Sub
   llngSubPlace = InStr(1, lstrTmp, "Sub", vbTextCompare)
   If llngSubPlace <> 0 Then
      ' Everything between Sub and ( is the name of the Sub
      llngParenPlace = InStr(1, lstrTmp, "(")
      If llngParenPlace <> 0 Then
         lstrSubName = Trim(Mid(lstrTmp, llngSubPlace + Len("Sub"), _
               llngParenPlace - llngSubPlace - Len("Sub")))
      End If
   Else
      lstrSubName = ""
   End If
   
   GetSubName = lstrSubName
   
End Function

Private Function GetArgLine(ByVal vstrFCode As String) As String
   Dim lstrTmp As String
   Dim lstrArgList As String
   Dim llngPos As Long
   
   lstrTmp = PrepareVBFunction(vstrFCode)
   
   ' Find the first "("
   llngPos = InStr(1, lstrTmp, "(")
   If llngPos <> 0 Then
      If InStr(llngPos, lstrTmp, ")") <> 0 Then
         ' Everything in between is the argument list
         lstrArgList = Trim(Mid(lstrTmp, llngPos + 1, InStr(llngPos, lstrTmp, ")") - llngPos - 1))
      Else
         lstrArgList = ""
      End If
   Else
      lstrArgList = ""
   End If
   
   GetArgLine = lstrArgList

End Function

Private Function GetSubHeader(ByVal vstrFCode As String) As String
   Dim lstrTmp As String
   Dim laryLines As Variant
   
   lstrTmp = PrepareVBFunction(vstrFCode)
   
   laryLines = Split(lstrTmp, vbCrLf)
   
   ' Get first line
   GetSubHeader = laryLines(UBound(laryLines))
   
End Function


